Package org.kie.internal.conf

## Enum IndexPrecedenceOption

- java.lang.Object
- - java.lang.Enum<IndexPrecedenceOption>
  - - org.kie.internal.conf.IndexPrecedenceOption

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<IndexPrecedenceOption>`, `org.kie.api.conf.KieBaseOption`, `org.kie.api.conf.Option`, `org.kie.api.conf.SingleValueKieBaseOption`, `org.kie.api.conf.SingleValueOption`, `org.kie.api.conf.SingleValueRuleBaseOption`

      public enum IndexPrecedenceOption
      extends java.lang.Enum<IndexPrecedenceOption>
      implements org.kie.api.conf.SingleValueRuleBaseOption

  An Enum for Index Precedence option. drools.indexPrecedence = <pattern|equality> When creating indexes gives precedence to the equality constraints (default) or to the first indexable constraint in the pattern. DEFAULT = equality

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `EQUALITY_PRIORITY` |
    `PATTERN_ORDER` |

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static org.kie.api.conf.OptionKey<IndexPrecedenceOption>` | `KEY` |
    `static java.lang.String` | `PROPERTY_NAME` | The property name for the index precedence option

    - ### Fields inherited from interface org.kie.api.conf.SingleValueRuleBaseOption

      `TYPE`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static IndexPrecedenceOption` | `determineIndexPrecedence​(java.lang.String mode)` |
    `java.lang.String` | `getPropertyName()`
    `java.lang.String` | `getValue()` |
    `java.lang.String` | `toExternalForm()` |
    `java.lang.String` | `toString()` |
    `static IndexPrecedenceOption` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static IndexPrecedenceOption[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.kie.api.conf.Option

      `propertyName`

    - ### Methods inherited from interface org.kie.api.conf.SingleValueRuleBaseOption

      `type`

- - ### Enum Constant Detail

    - #### PATTERN_ORDER

          public static final IndexPrecedenceOption PATTERN_ORDER

    - #### EQUALITY_PRIORITY

          public static final IndexPrecedenceOption EQUALITY_PRIORITY

  - ### Field Detail

    - #### PROPERTY_NAME

          public static final java.lang.String PROPERTY_NAME

      The property name for the index precedence option
      See Also:
        Constant Field Values

    - #### KEY

          public static org.kie.api.conf.OptionKey<IndexPrecedenceOption> KEY

  - ### Method Detail

    - #### values

          public static IndexPrecedenceOption[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (IndexPrecedenceOption c : IndexPrecedenceOption.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static IndexPrecedenceOption valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getPropertyName

          public java.lang.String getPropertyName()

      Specified by:
        `getPropertyName` in interface `org.kie.api.conf.Option`

    - #### getValue

          public java.lang.String getValue()

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Enum<IndexPrecedenceOption>`

    - #### toExternalForm

          public java.lang.String toExternalForm()

    - #### determineIndexPrecedence

          public static IndexPrecedenceOption determineIndexPrecedence​(java.lang.String mode)